function [rxnsYs, notY] = checkSensorRxns(model, from, to)

notGeneRelatedNum = 0;
notKnockablesNum = 0;
noInfluenceNum = 0;
rxnsYs = ones(to-from+1,1);

%check Y's
for i=from:to

    if (i <= model.origRxnNum && max(model.rxnGeneMat(i,:)) == 0)     %find if the reaction is gene related
        rxnsYs(i) = 0;        
        notGeneRelatedNum=notGeneRelatedNum+1;        
    else             %find if the gene is knockable
        c=zeros(model.rxnNum,1);
        c(i)=1;
        ub=model.ub;
        ub(i)=0;
        lb=model.lb;
        lb(i)=0;

        Prob = lpAssign( -c, model.S, model.row_lb, model.row_ub, lb, ub);
        Result = tomRun('cplex', Prob,0);

        if (Result.ExitFlag ~=0)
            rxnsYs(i) = 0;
            %notYInd(end+1)=i;
            notKnockablesNum=notKnockablesNum+1;
        else           %check if it makes a difference
            ub(i)=model.ub(i);
            lb(i)=model.lb(i);

            Prob2 = lpAssign( -c, model.S, model.row_lb, model.row_ub, lb, ub);
            Result2 = tomRun('cplex', Prob2,0);

            Prob3 = lpAssign( c, model.S, model.row_lb, model.row_ub, lb, ub);
            Result3 = tomRun('cplex', Prob3,0);

            if (Result3.f_k == Result2.f_k && Result3.f_k ==0)
                rxnsYs(i) = 0;                
                noInfluenceNum=noInfluenceNum+1;
   
            end
        end
    end
end

notY.notGeneRelatedNum=notGeneRelatedNum;
notY.notKnockablesNum=notKnockablesNum;
notY.noInfluenceNum=noInfluenceNum;

% notYInd=sort(notYInd)';
% yInd=sort(yInd)';