function [modelU, modelV, yInd, notYInd, notY, twoSidedInds, oneSidedInds, reversedInds]=createSensorModels(boundedMediaFlag, maxRxnsSize, uptakeChemicalInd, organismObjectiveInd, maxUptakeRate, biomassThrsh, modelFlag, uMediaFlag, vMediaFlag)

% if I will use reduced models I will have to re-calculate the
% objective function and the sensored chemical
if (modelFlag == 0) %ecoli    
        load('Ecoli_iJR904.mat');
        model = Ecoli_iJR904;    
else   
    load('Yeast_iND750');
    model = Yeast_iND750;
end
[metNum rxnNum] = size(model.S);
model.row_ub = zeros(metNum,1);
model.row_lb = zeros(metNum,1);
model.rxnNum = rxnNum;
model.origRxnNum = rxnNum;
model.organismObjectiveInd =  organismObjectiveInd;
model.C_chemical = zeros(rxnNum,1);
model.C_chemical(uptakeChemicalInd) = 1;
model.uptakeChemicalInd = uptakeChemicalInd;
%arrange parameters
model.metNum = metNum;
model.rxnNum = rxnNum;
model.row_ub = zeros(metNum,1);
model.row_lb = zeros(metNum,1);
%create objective functions
model.c=zeros(rxnNum,1);
model.c(organismObjectiveInd)=1;

%create 2 models - one with rich media without the chemical sensored, other with rich  media
%+ chemicals secreted from e-coli

%find exchange reaction to add to the the models
if (boundedMediaFlag && modelFlag == 0)
    load('EcoliWithAddExchangeReactions');
else
    exchange_reactions = strmatch('EX_',model.rxns);
end
modelU = model;
if (uMediaFlag) %rich media
    modelU.lb(exchange_reactions)=-maxRxnsSize;
end
modelU.lb(uptakeChemicalInd) = -maxUptakeRate;   %add uptake chemical
modelU.lb(organismObjectiveInd) = biomassThrsh;

modelV = model;
if (vMediaFlag) %rich media
    modelV.lb(exchange_reactions)=-maxRxnsSize;
end
modelV.lb(uptakeChemicalInd)=0;

% m - number of rxns
% n - number of metabolites
% twoSided - rxns that can flow in 2 directions
% oneSided - rxns that can flow in one directions
% reversed - rxns that are reversed
[modelU, twoSided1, oneSided, reversed] = arrangeDirections(modelU, uptakeChemicalInd);
[modelV, twoSided, oneSided, reversed] = arrangeDirections(modelV, uptakeChemicalInd);

%arrange direction vectors
reversedInds = find(reversed);
oneSidedInds = find(oneSided);
twoSidedInds = find(twoSided);

%find Ys and remove reactions that are not used
%function parameters:
% notY - statistics
%rxnsYs - a boolean array. '0' - the reaction can not knocked
[rxnsYsU, notY]= checkSensorRxns(modelU, 1, rxnNum);
rxnsYs = rxnsYsU;
% yInd - indexes of reactions that can be removed 
% notYInd  -  indexes of reactions that can not be removed or added
yInd = find(rxnsYs);
notYInd = find(rxnsYs == 0);

 %add no secretion to objective of modelV
if (isempty(find(reversed==modelV.uptakeChemicalInd,1)) )    %the reaction is NOT reversed
    modelAllSecreted.c(modelV.uptakeChemicalInd)=1;  %the objective function changed so no secretion will be at optimal point
end

