%parameters
folder = 'ecoli_poorPoor2';
uMediaFlag = 0; %0 is poor media
vMediaFlag = 0; %0 is poor media
modelFlag = 0; %1 is yeast

cd 'C:\Documents and Settings\naamat\My Documents\Technion\system biology\BioSensors';

if (modelFlag)
    load ('Yeast_iND750');
    model = Yeast_iND750;
    [ndata, genestext] = xlsread('mart_export.csv', 'mart_export'); %read genes list for yeast
else
    load('Ecoli_iJR904.mat');
    model = Ecoli_iJR904; 
    exchangeInds = strmatch('EX_',model.rxns);   
    mmd = exchangeInds(find(model.lb(exchangeInds) < 0));
end

[metNum rxnNum] = size(model.S);
model.row_ub = zeros(metNum,1);
model.row_lb = zeros(metNum,1);
model.C_chemical = zeros(rxnNum,1);

cd 'C:\Documents and Settings\naamat\My Documents\Technion\system biology\BioSensors\results';
r=CondorLoadBioSensors(folder);
resNum=length(r);

interestingRxns=[];
interestingNums=[];
interestingResults={};
if (uMediaFlag)  %rich media
    results = {'Chemical Name', 'Chemical Index', 'number of knockouts', 'knocked reaction 1', 'knocked reaction 2','knocked reaction 3', 'maximal growth rate in rich media', 'knocked genes 1', 'knocked genes 2','knocked genes 3', 'max uptake rich media'};
else
    results = {'Chemical Name', 'Chemical Index', 'number of knockouts', 'knocked reaction 1', 'knocked reaction 2','knocked reaction 3', 'maximal growth rate in minimal media', 'knocked genes 1', 'knocked genes 2','knocked genes 3', 'max uptake minimal media', 'max uptake rich media',  'max growth  minimal media', 'max growth rich media', 'yield minimal media', 'yield rich media','maximal error'};
end
err={};
errNum=0;
arrivedResultsNum=0;
matlabCrash=[];

noKnockNoAddRxns = [];
oneKnockNoAddRxns = [];
twoKnockNoAddRxns = [];
threeKnockNoAddRxns = [];

%parse results
for i=1:resNum
    if (size(r{i},2)==1 )    %check that there is a result
        arrivedResultsNum=arrivedResultsNum+1;
        res=r{i}.Results;
        if (res.exitFlag ==0 )  %there is a results
            if ( ~(isempty(res.knockCheckV)) && ~(isempty(res.knockCheckU)) && abs(res.objective-res.knockCheckU.biomass)<1  && res.knockCheckV.biomass==0) %check errors
                if (res.objective >0.1)
                    if (isempty(find(interestingRxns==res.chemicalInd)) )
                        interestingRxns(end+1)=res.chemicalInd;
                    end
                    interestingResults{end+1}=res;
                    %no knockouts
                    if (isempty(res.knockedRxns))
                        interestingNums(end+1, :)=[i, res.chemicalInd, res.objective, res.uBiomassVal, res.knockCheckU.maxChemicalUptake, res.knockCheckU.minChemicalUptake, res.knockoutNum, 0,0,0];
                        noKnockNoAddRxns(end+1) = res.modelV.chemicalInd;
                    else
                        if (length(res.knockedRxns)==1)
                            interestingNums(end+1, :)=[i, res.chemicalInd, res.objective, res.uBiomassVal, res.knockCheckU.maxChemicalUptake, res.knockCheckU.minChemicalUptake, res.knockoutNum, res.knockedRxns(1),0,0];
                            oneKnockNoAddRxns(end+1) = res.modelV.chemicalInd;
                        else
                            if (length(res.knockedRxns)==2)
                                interestingNums(end+1, :)=[i, res.chemicalInd, res.objective, res.uBiomassVal, res.knockCheckU.maxChemicalUptake, res.knockCheckU.minChemicalUptake, res.knockoutNum, res.knockedRxns(1),res.knockedRxns(2),0];
                                twoKnockNoAddRxns(end+1) = res.modelV.chemicalInd;
                            else  %three knockouts
                                interestingNums(end+1, :)=[i, res.chemicalInd, res.objective, res.uBiomassVal, res.knockCheckU.maxChemicalUptake, res.knockCheckU.minChemicalUptake, res.knockoutNum, res.knockedRxns(1),res.knockedRxns(2),res.knockedRxns(3)];
                                threeKnockNoAddRxns(end+1) = res.modelV.chemicalInd;
                            end
                        end
                    end
                end
            else
                errNum=errNum+1;
                err{end+1}=r{i};
            end
        end
    else
        matlabCrash(end+1) = i;
    end
end

str=sprintf('C:\\Documents and Settings\\naamat\\My Documents\\Technion\\system biology\\BioSensors\\Figures\\%s', folder);
mkdir(str);
cd (str);
interestingRxns = [];
%interestingNums = sortrows(interestingNums, [2 -3 7]);
interestingNums = sortrows(interestingNums, 7); %sory by number of knockouts
yields = [];
for i=1:size(interestingNums,1)
    chemicalInd = interestingNums(i,2);
    if (isempty(find(interestingRxns == chemicalInd)) )
        interestingRxns(end+1)=chemicalInd;
        res = interestingNums(i,:);
        model = r{res(1)}.Results.modelU;
        chemicalName = model.rxnNames(res(2));
        knock1={''};
        knock2={''};
        knock3 ={''};

        if (res(7)==0 || res(8)==0)
            knockNum = 0;
            interestingNums(i,7)=0;
            str=sprintf('%s index %d.  growth: %d. No knocked or added reactions'  ,chemicalName{1}, res(2), res(5));
        else
            if (res(7)==1 || res(9)==0)
                knockNum = 1;
                interestingNums(i,7)=1;
                knock1=model.rxnNames(res(8));
                str=sprintf('%s.  growth: %d. uptake rates: [%d %d]. knocked reaction: %s'  ,chemicalName{1}, res(3), -res(5), -res(6), knock1{1});
            else
                if (res(7)==2 || res(10)==0)
                    knockNum = 2;
                    interestingNums(i,7)=2;
                    knock1=model.rxnNames(res(8));
                    knock2=model.rxnNames(res(9));
                    str=sprintf('%s.  growth: %d. uptake rates: [%d %d]. knocked reaction: %s, %s'  ,chemicalName{1}, res(3), -res(5), -res(6), knock1{1}, knock2{1});
                else  %three knockouts
                    knockNum = 3;
                    interestingNums(i,7)=3;
                    knock1=model.rxnNames(res(8));
                    knock2=model.rxnNames(res(9));
                    knock3=model.rxnNames(res(10));
                    str=sprintf('%s.  growth: %d. uptake rates: [%d %d]. knocked reaction: %s, %s, %s'  ,chemicalName{1}, res(3), -res(5), -res(6), knock1{1}, knock2{1}, knock3{1});
                end
            end
        end
        str

        if (uMediaFlag || isempty(find(mmd == res(2))))
            mediaFlag = 'no';

            genes = model.grRules([max(res(8),1), max(res(9),1), max(res(10),1)]);
            if (modelFlag)
                %replace genes names
                for j=2:length(genestext)
                    genes{1} = strrep(genes{1}, genestext(j,1), genestext(j,2));
                    genes{2} = strrep(genes{2}, genestext(j,1), genestext(j,2));
                    genes{3} = strrep(genes{3}, genestext(j,1), genestext(j,2));
                end
            end
            subSys =  model.subSystems(res(2));
            nameStr = strrep(strrep(chemicalName, ',', ''), ' exchange', '');

            [fig, maxUptakeV, maxUptakeU, maxGrowthV, maxGrowthU, maxErr] = createSensorFigure(res(2), uMediaFlag, vMediaFlag, modelFlag, r{res(1)}.Results.knockedRxns);
            yieldV = maxGrowthV/maxUptakeV;
            yieldU = maxGrowthU/maxUptakeU;
            yields(end+1,:) = [yieldU, yieldV];
            if (uMediaFlag) %rich media
                result = {nameStr{1}, res(2), knockNum, knock1{1}, knock2{1}, knock3{1}, res(3), genes{1}, genes{2}, genes{3}, maxUptakeU};
            else
                result = {nameStr{1}, res(2), knockNum, knock1{1}, knock2{1}, knock3{1}, res(3), genes{1}, genes{2}, genes{3}, maxUptakeU, maxUptakeV, maxGrowthU, maxGrowthV,yieldU, yieldV, maxErr};
            end
            results = [results; result];
        else
            'in minimal media'
            mediaFlag = 'yes';
        end
    end
end

%create histograms
uYield = sort(yields(:,1));
vYield = sort(yields(:,2));

subplot(1,2,1)
hist(uYield, 20)
xlabel('yield');
ylabel('number of sensors');
title('minimal media', 'FontSize', 13);
subplot(1,2,2)
hist(vYield, 20)
xlabel('yield');
ylabel('number of sensors');
title('rich media', 'FontSize', 13);
saveas(gcf,'yield histogram','fig');
saveas(gcf,'yield histogram','jpg');

yieldDiff = vYield - uYield;
hist(yieldDiff, 20)
xlabel('rich media yield minus minimal media yield');
ylabel('number of sensors');
title('yield differencec', 'FontSize', 13);
saveas(gcf,'yield difference histogram','fig');
saveas(gcf,'yield difference histogram','jpg');

uYield2 = sort(uYield);
vYield2 = sort(vYield);
uYield = uYield2(1:end-5);
vYield = vYield2(1:end-5);
subplot(1,2,1)
hist(uYield2, 20)
xlabel('yield');
ylabel('number of sensors');
title('minimal media', 'FontSize', 13);
subplot(1,2,2)
hist(vYield2, 20)
xlabel('yield');
ylabel('number of sensors');
title('rich media', 'FontSize', 13);
saveas(gcf,'yield histogram small','fig');
saveas(gcf,'yield histogram small','jpg');

%add number of error and the result folder used
str1 = sprintf('number of errors is %d', errNum);
str2 = sprintf('result folder used: %s', folder);
if (uMediaFlag) %rich media
    result1 = {str1, '', '', '', '','' , '', '', '', '', ''};
    result2 = {str2, '', '', '', '','' , '', '', '', '', ''};
else
    result1 = {str1, '', '', '', '','' , '', '', '', '', '', '', '', '', '', '', ''};
    result2 = {str2, '', '', '', '','' , '', '', '', '', '', '', '', '', '', '', ''};
end
results = [results; result1; result2];

cd 'C:\Documents and Settings\naamat\My Documents\Technion\system biology\BioSensors\results';
str = sprintf('%s.xls', folder);
[status, message] = xlswrite(str, results)

