%parameters
boundedMediaFlag=1;        %rich media contains only chemicals that can be secreted from e-coli according to the e.coli model
knockNum = 2;
maxUptakeRate = 10;   %uptake of glucose
modelFlag = 0;  %0 is e.coli 1 is yeast
uMediaFlag = 0; %0 is poor
vMediaFlag = 1; %0 is poor
chemicalInd = 289;  % the chemical to sense

%constants
maxW=1000;


if (modelFlag == 0)  %e-coli
    load('Ecoli_iJR904.mat');
    model=Ecoli_iJR904;
    biomassInd = [strmatch('Biomass', model.rxns) , strmatch('Ec_biomass', model.rxns) ];
    if(length(biomassInd) < 1),
        disp('No Biomass reaction found!');
        return;
    end
    if(length(biomassInd) > 1),
        disp('Too many Biomass reactions found!');
        return;
    end    
else   %yeast model
    load('Yeast_iND750');
    model = Yeast_iND750;
    biomassInd = strmatch('biomass', model.rxns);
end

bioSensor(chemicalInd, biomassInd, knockNum, maxW, boundedMediaFlag, maxUptakeRate, 0, modelFlag, uMediaFlag, vMediaFlag, 0);
 
      



