function res=sensorCheck(model, knockedRxns)
% assumption - the chemical uptake reaction is not reversed
res=[];

%find fluxes
[metNum rxnNum]=size(model.S);
row_lb = zeros(1, metNum);
row_ub = zeros(1, metNum);

ubNew=model.ub;
ubNew(knockedRxns)=0;
ubTmp = ubNew;
ubNew = ubTmp;

lbNew=model.lb;
lbNew(knockedRxns)=0;
lbTmp = lbNew;
lbNew = lbTmp;

%find optimal biomass and then force it
organismObjectiveInd = [strmatch('Biomass', model.rxns) , strmatch('Ec_biomass', model.rxns), strmatch('biomass', model.rxns) ];
c=zeros(1,rxnNum);
c(organismObjectiveInd) = 1;
ProbMaxBiomass=lpAssign(-c, model.S, row_lb, row_ub, lbNew, ubNew);
ResMaxBiomass=tomRun('cplex', ProbMaxBiomass, 0);
ubNew(organismObjectiveInd)=-ResMaxBiomass.f_k;
lbNew(organismObjectiveInd)=-ResMaxBiomass.f_k;

if (ResMaxBiomass.ExitFlag== 0)
    res.biomass=-ResMaxBiomass.f_k;

    %maximum uptake and matching fluxes
    Prob_maxChemical=lpAssign(model.C_chemical, model.S, row_lb, row_ub, lbNew, ubNew);
    Result_maxChemical=tomRun('cplex', Prob_maxChemical, 0);
    res.maxChemicalUptake=-Result_maxChemical.f_k;    
    
    %minimum uptake and fluxes
    model.ub(find(model.C_chemical))=0;
    Prob_minChemical=lpAssign(-model.C_chemical, model.S, row_lb, row_ub, lbNew, ubNew);
    Result_minChemical=tomRun('cplex', Prob_minChemical, 0);
    res.minChemicalUptake=Result_minChemical.f_k;
end
