function [A_w,Ay_w ,B_w,C_w, lb_w, ub_w, wSize, wZs, row, var, sense, comp]=seperateTransposeJoin(A, Ay, B,C,ySize, highNum, zSize, twoSided, oneSided, indicatorFlag)
%Return maximum function under the following assumptions:
%1. y is not in the objective function.
%2. each original value v has a realtion with one y variable at the most
%3. it is a minimum problem with constraint Ax>=B

maxW=0;
%seperation
%min c1*v
%s.t
%A*v >= B-Ay*y

%change so:
%min c1*v1+c2*v2
%s.t
%A1*v1+A2*v2>=B-Ay*y
%v1>=0
%v2 free
A1=sparse(A(:,oneSided));
A2=sparse(A(:,twoSided));
C1=C(oneSided);
C2=C(twoSided);
aSizeCol1 = size(A1,2);
aSizeCol2 = size(A2,2);

%transpose
%max ( B-Ay*y)'w=B'w-(Ay*y)'w
%s.t
%A1'*w<=c1
%A2'*w=c2;
%w>=0

wSize=size(A',2);

if (indicatorFlag)    
    Cz=zeros(zSize,1);
    zInd = 1;  
    wZs=zeros(zSize,1);
    row = sparse(2*zSize, wSize+zSize);
    sense = sparse(2*zSize,1);
    var = sparse(2*zSize,1);            
    comp = sparse(2*zSize,1);
%     row - a vector of the constraints of w and z
%     var - the associated y variable
%     sense - 0 is '<=',  1 is '=='
%     comp - 0 means that the constraint is active when y equals to 1
    
     for k=1:wSize
        [maxVal,indMax]=max(Ay(k,:));
        [minVal,indMin]=min(Ay(k,:));
        if (maxVal~=0)
            val=maxVal;
            ind=indMax;
        end
        if (minVal~=0)  %for minus values
            val=minVal;
            ind=indMin;
        end
        if (maxVal~=0  || minVal~=0)
            Cz(zInd,1)=val;
            wZs(zInd)=k;
            
            vec = zeros(1,wSize+zSize);            
            vec(wSize+zInd) = 1;
            row(zInd, :) = vec;
            sense(zInd) = 0;
            var(zInd) = ind;            
            comp(zInd) = 1;
            
            vec(k) = -1;
            row(zSize+zInd, :) = vec;
            sense(zSize+zInd) = 1;
            var(zSize+zInd) = ind;            
            comp(zSize+zInd) = 0; 
            
            zInd=zInd+1;
        end
     end
    
    HConst=zeros(0,1);
    Hy=sparse(0,ySize);
    D=sparse(0,wSize+zSize);    

else
    row = [];
    var = [];
    sense = [];
    comp = [];
    %force linearity by: z=y*w
    %max ( B-Ay*y)'w=B'w-cy'z
    %s.t
    %A1'*w<=c1
    %A2'*w=c2;
    %D(w,z)<=H
    %z,w>=0

    wMax=highNum*ones(wSize,1);

    HConst=zeros(3*zSize,1);
    Hy=sparse(3*zSize,ySize);
    D=sparse(3*zSize,wSize+zSize);
    Cz=zeros(zSize,1);
    zInd=1;
    wZs=zeros(zSize,1);

    d1=[0;1;-1];
    d2=[1;-1;1];
    hc=[0;1;0];
    hy=[-1;1;0];

    for k=1:wSize
        val = 0;
        [maxVal,indMax]=max(Ay(k,:));
        [minVal,indMin]=min(Ay(k,:));
        if (maxVal~=0)
            val=maxVal;
            ind=indMax;
        end
        if (minVal~=0)  %for minus values
            val=minVal;
            ind=indMin;
        end
        if ((~isempty(maxVal)  || ~isempty(minVal)) && val ~=0)
            constInd=3*zInd-2:3*zInd;
            Cz(zInd,1)=val;
            D(constInd,k)=d1;
            D(constInd,zInd+wSize)=d2;
            HConst(constInd)=wMax(k,1)*hc;
            Hy(constInd,ind)=wMax(k,1)*hy;
            wZs(zInd)=k;
            zInd=zInd+1;
        end
    end

    %new objective function
    %the new variables are (w,z,y)
    %max C_w(w  z)'
    %s.t
    %[A_w  Ay_w]*(w z y)  <=  B_w
    %z,w>=0
    D = sparse(D);
    Hy = sparse(Hy);
end

   C_w=[B;
    -Cz
    ];
A_w=[
    A1', sparse(aSizeCol1, zSize);
    A2', sparse(aSizeCol2, zSize);
    -A2', sparse(aSizeCol2, zSize);
    D;
    ];
Ay_w=[
    sparse(aSizeCol1+2*aSizeCol2, ySize);
    Hy;
    ];
B_w=[
    C1;
    C2;
    -C2;
    HConst;
    ];

lb_w=zeros(wSize+zSize, 1);
%ub_w=highNum*ones(wSize+zSize, 1);
if (indicatorFlag)
  ub_w=inf*ones(wSize+zSize, 1);
else
    ub_w=highNum*ones(wSize+zSize, 1);
end



